#!/usr/bin/perl -w

use LWP::Simple;
use Getopt::Std;


$BASE_URL = "http://www.skynow.co.uk/tvguide/tv_channel.jsp?channel=";
$CHANNELS = "channels.txt"; # database for channel listings
$DIALOG = "/usr/bin/dialog"; # Location of dialog
$USE_CURSES = 0;


$version = "0.9fix";


$o = { };

Getopt::Std::getopt('G:c:v:h:l', $o);

if (exists($o->{'c'})) { 
		if (RealChannel($o->{'c'}) ne "yes") { die "$o->{'c'}: Invalid Channel!\n"; };
		my $html = GetHTML($o->{'c'});
		print "\n\t\t\tListings For: $o->{'c'}\n\n";
		FormatHTML($html);
		exit(0);
}
elsif (exists($o->{'G'})) { DialogOutput(); } 
elsif (exists($o->{'v'})) { print "skytvguide.pl $version\n"; exit(0); }
elsif (exists($o->{'l'})) { ListChannels(); exit(0); }
else { PrintHelp(); exit(1); };


#my $raw_html = GetHTML("SKY_ONE");
#FormatHTML($raw_html);

sub DialogOutput {

	$USE_CURSES = 1;

	if (! -f $DIALOG) { die "$DIALOG: Does Not Exist\n"; };
	my $channel = 0;
	until (0) {
		if (defined($schedule)) { undef($schedule); };
		if (defined($menu)) { undef($menu); };

		open (DATA,"$CHANNELS") || die "$CHANNELS: Can't Open!\n";
		foreach (<DATA>) {
			chomp();
			my @info = split(/ /,$_);
			#$menu .= qq("$info[0]" "$info[0]" );
			$menu .= qq("$info[0]" "" );
		}
		close (DATA);

	my $channel = Dialog("Main Menu","menu",$menu);
	if (RealChannel($channel) ne "yes") { exit(0); };
	my $html = GetHTML($channel);	
	FormatHTML($html);
	Dialog("Listings For $channel","menu",$schedule);
	}

	exit(0);
}
sub RealChannel {
	my $channel = shift;

	if (!defined($channel)) { die "No Channel Specified!\n"; };
	open (CHANNELS,"$CHANNELS") || die "$CHANNELS: Can't Open!\n";
	while (<CHANNELS>) {
		chomp();
		my @temp_info = split(/ /,$_);
		if ($channel eq $temp_info[0]) { return("yes"); };
	}
	close (CHANNELS);
}

sub ListChannels {
	
	open (CHANNELS,"$CHANNELS") || die "$CHANNELS: Can't Open!\n";

	while (<CHANNELS>) {
		chomp($_);
		my @temp_info = split(/ /,$_);
		print "\t$temp_info[0]\n";
	}

	close (CHANNELS);
}

sub PrintHelp {
print <<"HELP";
skytvguide.pl v$version                          (m.rowlands\@bangor.ac.uk)

syntax:

	skytvguide.pl
			-G       GUI Mode (Requires Dialog)

			-l       Lists Channels
			-c [n]   Prints Listings For Channel [n]
			-v       Prints Version
			-h       This Screen

HELP

}

sub ConsoleOutput {
	my $time = shift;
	my $show = shift;

format top=
 |   Time   |                      Programme Name                          | 
 |----------|--------------------------------------------------------------|
.
format STDOUT=
 |  @<<<<<  | @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< |
    $time,    $show
.


write;

}

sub FormatHTML {

	my $html = shift;
	my $data;
	
	foreach (split(/\n/,$html)) { 
		s/<(?:[^>'"]*|(['"]).*?\1)*>//gs; 
		if (/\&nbsp\;/) { # We're only interested in lines with &nbsp's 
			s/&nbsp\;/\n/gs; # Replace &nbps's With \n's
			s/^\n//gs; # Dump Blank Lines	
			#/((\d\d|\d):\d\d)/;			
			/(\d+:\d+)(.+)/;			
		   	if (defined($1)) { 		
				if ($USE_CURSES eq 0) { ConsoleOutput($1,$2); }
				else { $schedule .= qq("$1" "$2" ); };
			}	
		};
	}; 

}


sub GetHTML {
	my $channel = shift;

	if (!defined($channel)) { die "No Channel Specified!\n"; };
	if (!defined($BASE_URL)) { die "No Base URL Defined!\n"; };

	my $data = get("$BASE_URL$channel");
	return($data);
}

sub Dialog {
        my $title = shift;
        my $type = shift;
        my $misc = shift;

        my $box = "$DIALOG --title \"skytvguide.pl v$version - m.rowlands\@bangor.ac.uk\" ";
        $box .= "--$type \"$title\" 20 60 11 $misc";

        my $channel = `$box 3>&1 1>&2 2>&3 3>&-`;
        return ($channel);
}

